#include "descriptor/descriptor.h"

#define nparti 9

ITEM	moto[nparti];

void transla_vespa(double x,double y,double z);
void ruota_vespa(int asse,int angolo);

int main(void)
{	
	ITEM	grigio_metallizzato,nero,arancione,rosso,vetro,vetro_trasp,vetro_trasp2,legno;
	ITEM	colore_parete,colore_copert,bianco,pagina_scritta,colore_punta;
	ITEM 	chiusuramarmitta,parti_grigie,parti_nere,parti_arancione,trazione_ant;
	ITEM	specchietti,fanale_anteriore,fanale_posteriore,cavalletto,copertone_ant;
	ITEM 	base_scrivania,specchio,parete,copertina,insieme_pagine,pagina1,pagina2;
	ITEM	fondo_penna,corpo_penna,punta_penna,penna;
	ITEM 	scene;
	
	

	/*PARAMETRI GLOBALI SCENA*/
	set_background(1,1,1,TRUE);
	set_ambient_light(1,1,1,1);
	create_point_light(10,15,20,1,1,1,2,0, "point_light1");
	//create_point_light(20.335,1.603,19.652,1,1,1,2,0, "point_light2");
	create_warn_light(1,0,10,-1.5,0,-10,1,1,1,5,25,1,0.25,FALSE,0,0,0,0,"light2");

	/*ATTRIBUTI*/
	grigio_metallizzato=create_attribute("grigio_metallizzato");
	set_color(grigio_metallizzato,0.81,0.81,0.81,0.5,0.5);
	set_reflectivity(grigio_metallizzato,0.1,2);

	nero=create_attribute("nero");
	set_color(nero,0,0,0,0.2,0.2);

	bianco=create_attribute("bianco");
	set_color(bianco,1,1,1,0.5,0.5);

	colore_copert=create_attribute("marrone");
	set_color(colore_copert,0.5,0.5,0.3,0.2,0.2);

	arancione=create_attribute("arancione");
	set_color(arancione,0.1,0.1,0.1,0.5,0.5);
	set_reflectivity(arancione,0.05,2);
	
	colore_parete=create_attribute("colore_parete");
	set_color(colore_parete,0.6,0.5,0.3,0.4,0.4);
	
	rosso=create_attribute("rosso");
	set_color(rosso,0.1,0.1,0.1,0.5,0.5);
	set_reflectivity(rosso,0.05,2);

	vetro = create_attribute("vetro");
        set_color(vetro,1,1,1,0,0);
        set_reflectivity(vetro,0.8,10);

	vetro_trasp = create_attribute("vetro");
        set_color(vetro_trasp,0.6,0.6,1,0.5,0.5);
  	set_reflectivity(vetro_trasp,0.24,2);
 	set_transparency(vetro_trasp,1,1,1,1.2);

	vetro_trasp2 = create_attribute("vetro");
	set_color(vetro_trasp2,0.8,0.8,0.8,0,0);
  	set_reflectivity(vetro_trasp2,0.1,2);
 	set_transparency(vetro_trasp2,1,1,1,1.2);

	legno=create_attribute("legno");
	set_color(legno,0.45,0.25,0.15,0.5,0.5);
        set_reflectivity(legno,0.01,2);

	pagina_scritta=create_attribute("pagina_scritta");
	set_color(bianco,1,1,1,0.2,0.2);

	
	/*OGGETTI*/
  
	parti_arancione = read_obj("partiarancione.obj","parti_arancione");
	set_projection_texture(parti_arancione,arancione,"textures/arancione.hr",0,TRUE,0.3,0.2);
	set_scale(parti_arancione,2,2,2);
	set_z_rotate(parti_arancione,-45,1);
	set_translate(parti_arancione,-1,2,0.05);
		
	parti_nere = read_obj("partinere.obj","parti_nere");
	set_attribute (parti_nere,nero);
	set_scale(parti_nere,2,2,2);
	set_z_rotate(parti_nere,-45,1);
	set_translate(parti_nere,-1,2,0.05);

	parti_grigie = read_obj("partigrigie.obj","parti_grigie");
	set_projection_texture(parti_grigie,grigio_metallizzato,"textures/grigiometallizzato.hr",0,TRUE,0.3,0.2);
	set_scale(parti_grigie,2,2,2);
	set_z_rotate(parti_grigie,-45,1);
	set_translate(parti_grigie,-1,2,0.05);

	trazione_ant = read_obj("trazioneant.obj","trazione_ant");
	set_projection_texture(trazione_ant,grigio_metallizzato,"textures/grigiometallizzato.hr",0,TRUE,0.3,0.2);
	set_scale(trazione_ant,2,2,2);
	set_z_rotate(trazione_ant,-45,1);
	set_translate(trazione_ant,-1,2,0.05);
	
	copertone_ant = read_nurbs("ruotasurface.db");
	set_attribute(copertone_ant,nero);
	set_scale(copertone_ant,2,2,2);
	set_z_rotate(copertone_ant,-45,1);
	set_translate(copertone_ant,-1,2,0.05);

	specchietti = read_obj("specchietti.obj","specchietti");
	set_attribute(specchietti,vetro);
	set_scale(specchietti,2,2,2);
	set_z_rotate(specchietti,-45,1);
	set_translate(specchietti,-1,2,0.05);

	fanale_anteriore = read_nurbs("fanale_anttrasparentetrim.db");
	set_attribute(fanale_anteriore,vetro_trasp2);
	set_scale(fanale_anteriore,2,2,2);
	set_z_rotate(fanale_anteriore,-45,1);
	set_translate(fanale_anteriore,-1,2,0.05);

	fanale_posteriore = read_nurbs("fanale_posteriore.db");
	set_projection_texture(fanale_posteriore,rosso,"textures/rosso.hr",0,TRUE,0.3,0.2);
	set_scale(fanale_posteriore,2,2,2);
	set_z_rotate(fanale_posteriore,-45,1);
	set_translate(fanale_posteriore,-1,2,0.05);

	cavalletto = read_nurbs("cavalletto.db");
	set_attribute(cavalletto,nero);
	set_scale(cavalletto,2,2,2);
	set_z_rotate(cavalletto,-45,1);
	set_translate(cavalletto,-1,2,0.142);

	base_scrivania = read_nurbs("basescrivania.db");
	set_projection_texture(base_scrivania,legno,"textures/wood.hr",0,TRUE,0.3,0.2);
	set_scale(base_scrivania,10,12,10);
	set_z_rotate(base_scrivania,45,1);	
	set_translate(base_scrivania,1,2,-1.3);
	
	parete = read_nurbs("parete.db");
	set_attribute(parete,colore_parete);
	set_scale(parete,1,10,10);
	set_z_rotate(parete,45,1);
	set_translate(parete,0,0,0);
	

	specchio = read_nurbs("specchio.db");
	set_attribute(specchio,vetro);
	set_scale(specchio,4,1,3);
	set_z_rotate(specchio,-45,1);
	set_translate(specchio,-0.4,3,1);

	copertina = read_obj("copertina.obj","copertina");
	set_attribute(copertina,colore_copert);
	set_scale(copertina,0.22,0.2,0.2);
	set_z_rotate(copertina,45,1);
	set_translate(copertina,3.7,-3,-1.1);

	insieme_pagine = read_obj("partibianchelibro.obj","insieme_pagine");
	//set_attribute(insieme_pagine,bianco);
	set_projection_texture(insieme_pagine,pagina_scritta,"textures/pagina_scritta.hr",0,TRUE,0.3,0.2);
	set_scale(insieme_pagine,0.22,0.2,0.2);
	set_z_rotate(insieme_pagine,45,1);
	set_translate(insieme_pagine,3.7,-3,-1.1);

	pagina1 = read_nurbs("paginascrittadx.db");
	set_domain_texture(pagina1,pagina_scritta,"textures/pagina_scritta.hr",0, 1,0,1,TRUE,0.6,0.8);
	set_scale(pagina1,0.22,0.2,0.2);
	set_z_rotate(pagina1,45,1);
	set_translate(pagina1,3.7,-3,-1.1);

	pagina2 = read_nurbs("paginascrittasx.db");
	set_domain_texture(pagina2,pagina_scritta,"textures/pagina_scritta.hr",0, 1,0,1,TRUE,0.6,0.8);
	set_scale(pagina2,0.22,0.2,0.2);
	set_z_rotate(pagina2,45,1);
	set_translate(pagina2,3.7,-3,-1.1);

	/*fondo_penna = read_nurbs("fondo.db");
	set_attribute(fondo_penna,nero);
	set_scale(fondo_penna,0.025,0.025,0.025);
	set_z_rotate(fondo_penna,45,1);
	set_translate(fondo_penna,1.5,0,-0.55);*/

	penna = read_obj("penna.obj","penna");
	set_attribute(penna,nero);
	set_scale(penna,0.025,0.025,0.025);
	set_z_rotate(penna,45,1);
	set_translate(penna,1.5,0,-0.55);

	/*
	punta_penna = read_nurbs("punta.db");
	set_attribute(punta_penna,nero);
	set_scale(punta_penna,0.025,0.025,0.025);
	set_z_rotate(punta_penna,45,1);
	set_translate(punta_penna,1.5,0,-0.55);*/



	scene = create_list(parti_arancione, "scene");
	scene = insert_in_list(scene, parti_nere);
	scene = insert_in_list(scene, parti_grigie);
	scene = insert_in_list(scene, trazione_ant);
	scene = insert_in_list(scene, copertone_ant);
	scene = insert_in_list(scene, specchietti);
	scene = insert_in_list(scene, fanale_anteriore);
	scene = insert_in_list(scene, fanale_posteriore);
	scene = insert_in_list(scene, cavalletto);
	scene = insert_in_list(scene, base_scrivania);
	scene = insert_in_list(scene, parete);
	scene = insert_in_list(scene, specchio);
	scene = insert_in_list(scene, copertina);
	scene = insert_in_list(scene, insieme_pagine);
	scene = insert_in_list(scene, pagina1);
	scene = insert_in_list(scene, pagina2);
	/*scene = insert_in_list(scene, fondo_penna);
	scene = insert_in_list(scene, corpo_penna);
	scene = insert_in_list(scene, punta_penna);*/
	scene = insert_in_list(scene, penna);
	
	moto[0]=parti_arancione;
  	moto[1]=parti_nere;
  	moto[2]=parti_grigie;
  	moto[3]=trazione_ant;
  	moto[4]=specchietti;
	moto[5]=fanale_anteriore;
	moto[6]=fanale_posteriore;
	moto[7]=cavalletto;
	moto[8]=copertone_ant;

	int i;
  
  	for (i=0;i<60;i++){
		switch (i){
			/*MOVIMENTO CAMEREA*/
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				break;
			case 5:
				break;
			case 6:
				break;
			case 7:
				break;
			case 8:
				break;
			case 9:
				break;
			/*ROTAZIONE PENNA*/
			case 10:
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.15,0.15,0);
				break;
			case 11:
				set_translate(penna,0.15,-0.15,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.3,0.3,0);
				break;
			case 12:
				set_translate(penna,0.3,-0.3,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.45,0.45,0);
				break;
			case 13:
				set_translate(penna,0.45,-0.45,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.6,0.6,0);
				break;
			case 14:
				set_translate(penna,0.6,-0.6,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.75,0.75,0);
				break;
			case 15:
				set_translate(penna,0.75,-0.75,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-0.9,0.9,0);
				break;
			case 16:
				set_translate(penna,0.9,-0.9,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.05,1.05,0);
				break;
			case 17:
				set_translate(penna,1.05,-1.05,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.2,1.2,0);
				break;
			case 18:
				set_translate(penna,1.2,-1.2,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.35,1.35,0);
				break;
			case 19:
				set_translate(penna,1.35,-1.35,0);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.5,1.5,-0.2);
				break;
			case 20:
				set_translate(penna,1.5,-1.5,0.2);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.65,1.65,-0.4);
				break;
			case 21:
				set_translate(penna,1.65,-1.65,0.4);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.8,1.8,-0.55);
				break;
			case 22:
				set_translate(penna,1.8,-1.8,0.55);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,-10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.95,1.95,-0.55);
				break;
			/*ROTAZIONE PENNA E RUOTA*/
			case 23:
				set_translate(penna,1.95,-1.95,0.55);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.8,1.8,-0.55);
				set_z_rotate(trazione_ant,-45,1);
				set_translate(trazione_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(trazione_ant,15,1);
				set_translate(trazione_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(trazione_ant,45,1);
				set_z_rotate(copertone_ant,-45,1);
				set_translate(copertone_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(copertone_ant,15,1);
				set_translate(copertone_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(copertone_ant,45,1);
				break;
			case 24:
				set_translate(penna,1.8,-1.8,0.55);
				set_z_rotate(penna,-45,1);
				set_translate(penna,-2.31066,0.95786,0.46097);
				set_x_rotate(penna,10,1);
				set_translate(penna,2.31066,-0.95786,-0.46097);
				set_z_rotate(penna,45,1);
				set_translate(penna,-1.65,1.65,-0.55);
				set_z_rotate(trazione_ant,-45,1);
				set_translate(trazione_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(trazione_ant,15,1);
				set_translate(trazione_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(trazione_ant,45,1);
				set_z_rotate(copertone_ant,-45,1);
				set_translate(copertone_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(copertone_ant,15,1);
				set_translate(copertone_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(copertone_ant,45,1);
				break;
			/*ROTAZIONE RUOTA ANTERIORE*/
			case 25:
			case 26:
			case 27:
			case 28:
			case 29:
			case 30:
				set_z_rotate(trazione_ant,-45,1);
				set_translate(trazione_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(trazione_ant,15,1);
				set_translate(trazione_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(trazione_ant,45,1);
				set_z_rotate(copertone_ant,-45,1);
				set_translate(copertone_ant,-1.72863,-2.21651,0.49952);
				set_x_rotate(copertone_ant,15,1);
				set_translate(copertone_ant,1.72863,2.21651,-0.49952);
				set_z_rotate(copertone_ant,45,1);
				break;
			/*MOVIMENTO CAMERA*/
			case 31:
			case 32:
			case 33:
			case 34:
			case 35:
			case 36:
				break;
			/*ROTAZIONE CAVALLETTO*/
			case 37:
			case 38:
			case 39:
			case 40:
			case 41:
				set_z_rotate(cavalletto,-45,1);
				set_x_rotate(cavalletto,9,1);
				set_translate(cavalletto,0,0,-0.678);
				set_z_rotate(cavalletto,45,1);
				break;
			/*ABBASSAMENTO MOTO*/
			case 42:
			case 43:
				transla_vespa(0,0,-0.025);
				break;
			/*MOVIMENTO CAMERA*/
			case 44:
			case 45:
			case 46:
			case 47:
			case 48:
			case 49:
			case 50:
			case 51:
				break;
			case 52:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.3);
				ruota_vespa(2,45);
				break;
			case 53:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.295);
				ruota_vespa(2,45);
				break;
			case 54:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.29);
				ruota_vespa(2,45);
				break;
			case 55:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.29);
				ruota_vespa(2,45);
				break;
			case 56:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.315);
				ruota_vespa(2,45);
				break;
			case 57:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.325);
				ruota_vespa(2,45);
				break;
			case 58:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				transla_vespa(0.2,0,0.36);
				ruota_vespa(2,45);
				break;
			case 59:
				ruota_vespa(2,-45);
				ruota_vespa(1,10);
				ruota_vespa(0,3);
				transla_vespa(0.2,0,0.18);
				ruota_vespa(2,45);
				break;
		}
	save_scene_ani(59,"vespa_animazione.ani","vespa_animazione","animazione_vespa",scene);
	}
	return(0);
}

void transla_vespa (double x,double y,double z){
	  int i;
	  for (i=0;i<nparti;i++)
		  set_translate(moto[i],x,y,z);
}
  
void ruota_vespa(int asse,int angolo){
	  int i;
	  switch(asse){
		  case 0:
			for (i=0;i<nparti;i++)
				set_x_rotate(moto[i],angolo,1);  
			break;
		case 1:				
			for (i=0;i<nparti;i++)
				set_y_rotate(moto[i],angolo,1);
			break;
		case 2:
			for (i=0;i<nparti;i++)
				set_z_rotate(moto[i],angolo,1);
			break;
	}
}
	




