#include "descriptor/descriptor.h"

int main(void)
{	
	ITEM	grigio_metallizzato,nero,arancione,rosso,vetro,vetro_trasp,vetro_trasp2,legno;
	ITEM	colore_parete,colore_copert,bianco,pagina_scritta,colore_punta;
	ITEM 	chiusuramarmitta,parti_grigie,parti_nere,parti_arancione;
	ITEM	specchietti,fanale_anteriore,fanale_posteriore,cavalletto;
	ITEM 	base_scrivania,specchio,parete,copertina,insieme_pagine,pagina1,pagina2;
	ITEM	fondo_penna,corpo_penna,punta_penna;
	ITEM 	scene;

	/*PARAMETRI GLOBALI SCENA*/
	set_background(1,1,1,TRUE);
	set_ambient_light(1,1,1,1);
	create_point_light(10,15,20,1,1,1,2,0, "point_light1");
	//create_warn_light(1,0,10,-1.5,0,-10,1,1,1,5,25,1,0.25,FALSE,0,0,0,0,"light2");

	/*ATTRIBUTI*/
	grigio_metallizzato=create_attribute("grigio_metallizzato");
	set_color(grigio_metallizzato,0.81,0.81,0.81,0.5,0.5);
	set_reflectivity(grigio_metallizzato,0.1,2);

	nero=create_attribute("nero");
	set_color(nero,0,0,0,0.2,0.2);

	bianco=create_attribute("bianco");
	set_color(bianco,1,1,1,0.5,0.5);

	colore_copert=create_attribute("marrone");
	set_color(colore_copert,0.5,0.5,0.3,0.2,0.2);

	arancione=create_attribute("arancione");
	set_color(arancione,0.1,0.1,0.1,0.5,0.5);
	set_reflectivity(arancione,0.05,2);
	
	colore_parete=create_attribute("colore_parete");
	set_color(colore_parete,0.6,0.5,0.3,0.4,0.4);
	
	rosso=create_attribute("rosso");
	set_color(rosso,0.1,0.1,0.1,0.5,0.5);
	set_reflectivity(rosso,0.05,2);

	vetro = create_attribute("vetro");
        set_color(vetro,1,1,1,0,0);
        set_reflectivity(vetro,0.8,10);

	vetro_trasp = create_attribute("vetro");
        set_color(vetro_trasp,0.6,0.6,1,0.5,0.5);
  	set_reflectivity(vetro_trasp,0.24,2);
 	set_transparency(vetro_trasp,1,1,1,1.2);

	vetro_trasp2 = create_attribute("vetro");
	set_color(vetro_trasp2,0.8,0.8,0.8,0,0);
  	set_reflectivity(vetro_trasp2,0.1,2);
 	set_transparency(vetro_trasp2,1,1,1,1.2);

	legno=create_attribute("legno");
	set_color(legno,0.45,0.25,0.15,0.5,0.5);
        set_reflectivity(legno,0.01,2);

	pagina_scritta=create_attribute("pagina_scritta");
	set_color(bianco,1,1,1,0.2,0.2);

	//colore_punta=create_attribute("colore_punta");
	//set_color(colore_parete,0,1,0,0.5,0.5);
	
	/*OGGETTI*/
  
	parti_arancione = read_obj("partiarancione.obj","parti_arancione");
	set_projection_texture(parti_arancione,arancione,"textures/arancione.hr",0,TRUE,0.3,0.2);
	set_scale(parti_arancione,2,2,2);
	set_z_rotate(parti_arancione,-45,1);
	set_translate(parti_arancione,-1,2,0.05);
		

	parti_nere = read_obj("partinere.obj","parti_nere");
	set_attribute (parti_nere,nero);
	set_scale(parti_nere,2,2,2);
	set_z_rotate(parti_nere,-45,1);
	set_translate(parti_nere,-1,2,0.05);

	parti_grigie = read_obj("partigrigie.obj","parti_grigie");
	set_projection_texture(parti_grigie,grigio_metallizzato,"textures/grigiometallizzato.hr",0,TRUE,0.3,0.2);
	set_scale(parti_grigie,2,2,2);
	set_z_rotate(parti_grigie,-45,1);
	set_translate(parti_grigie,-1,2,0.05);

	specchietti = read_obj("specchietti.obj","specchietti");
	set_attribute(specchietti,vetro);
	set_scale(specchietti,2,2,2);
	set_z_rotate(specchietti,-45,1);
	set_translate(specchietti,-1,2,0.05);

	fanale_anteriore = read_nurbs("fanale_anttrasparentetrim.db");
	set_attribute(fanale_anteriore,vetro_trasp2);
	set_scale(fanale_anteriore,2,2,2);
	set_z_rotate(fanale_anteriore,-45,1);
	set_translate(fanale_anteriore,-1,2,0.05);

	fanale_posteriore = read_nurbs("fanale_posteriore.db");
	set_projection_texture(fanale_posteriore,rosso,"textures/rosso.hr",0,TRUE,0.3,0.2);
	set_scale(fanale_posteriore,2,2,2);
	set_z_rotate(fanale_posteriore,-45,1);
	set_translate(fanale_posteriore,-1,2,0.05);

	cavalletto = read_nurbs("cavalletto.db");
	set_attribute(cavalletto,nero);
	set_scale(cavalletto,2,2,2);
	set_z_rotate(cavalletto,-45,1);
	set_translate(cavalletto,-1,2,0.142);



	base_scrivania = read_nurbs("basescrivania.db");
	set_projection_texture(base_scrivania,legno,"textures/wood.hr",0,TRUE,0.3,0.2);
	set_scale(base_scrivania,10,12,10);
	set_z_rotate(base_scrivania,45,1);	
	set_translate(base_scrivania,1,2,-1.3);
	

	parete = read_nurbs("parete.db");
	set_attribute(parete,colore_parete);
	set_scale(parete,1,10,10);
	set_z_rotate(parete,45,1);
	set_translate(parete,0,0,0);
	

	specchio = read_nurbs("specchio.db");
	set_attribute(specchio,vetro);
	set_scale(specchio,4,1,3);
	set_z_rotate(specchio,-45,1);
	set_translate(specchio,-0.4,3,1);

	copertina = read_obj("copertina.obj","copertina");
	set_attribute(copertina,colore_copert);
	set_scale(copertina,0.22,0.2,0.2);
	set_z_rotate(copertina,45,1);
	set_translate(copertina,3.7,-3,-1.1);

	insieme_pagine = read_obj("partibianchelibro.obj","insieme_pagine");
	set_projection_texture(insieme_pagine,pagina_scritta,"textures/pagina_scritta.hr",0,TRUE,0.3,0.2);
	set_scale(insieme_pagine,0.22,0.2,0.2);
	set_z_rotate(insieme_pagine,45,1);
	set_translate(insieme_pagine,3.7,-3,-1.1);

	pagina1 = read_nurbs("paginascrittadx.db");
	set_domain_texture(pagina1,pagina_scritta,"textures/pagina_scritta.hr",0, 1,0,1,TRUE,0.6,0.8);
	set_scale(pagina1,0.22,0.2,0.2);
	set_z_rotate(pagina1,45,1);
	set_translate(pagina1,3.7,-3,-1.1);

	pagina2 = read_nurbs("paginascrittasx.db");
	set_domain_texture(pagina2,pagina_scritta,"textures/pagina_scritta.hr",0, 1,0,1,TRUE,0.6,0.8);
	set_scale(pagina2,0.22,0.2,0.2);
	set_z_rotate(pagina2,45,1);
	set_translate(pagina2,3.7,-3,-1.1);

	fondo_penna = read_nurbs("fondo.db");
	set_attribute(fondo_penna,nero);
	set_scale(fondo_penna,0.025,0.025,0.025);
	set_z_rotate(fondo_penna,45,1);
	set_translate(fondo_penna,1.5,0,-0.55);

	corpo_penna = read_obj("corpo.obj","corpopenna");
	set_attribute(corpo_penna,vetro_trasp);
	set_scale(corpo_penna,0.025,0.025,0.025);
	set_z_rotate(corpo_penna,45,1);
	set_translate(corpo_penna,1.5,0,-0.55);

	punta_penna = read_nurbs("punta.db");
	set_attribute(punta_penna,nero);
	set_scale(punta_penna,0.025,0.025,0.025);
	set_z_rotate(punta_penna,45,1);
	set_translate(punta_penna,1.5,0,-0.55);



	


	/*SCENA*/
	scene = create_list(parti_arancione, "scene");
	scene = insert_in_list(scene, parti_nere);
	scene = insert_in_list(scene, parti_grigie);
	scene = insert_in_list(scene, specchietti);
	scene = insert_in_list(scene, fanale_anteriore);
	scene = insert_in_list(scene, fanale_posteriore);
	scene = insert_in_list(scene, cavalletto);
	scene = insert_in_list(scene, base_scrivania);
	scene = insert_in_list(scene, parete);
	scene = insert_in_list(scene, specchio);
	scene = insert_in_list(scene, copertina);
	scene = insert_in_list(scene, insieme_pagine);
	scene = insert_in_list(scene, pagina1);
	scene = insert_in_list(scene, pagina2);
	scene = insert_in_list(scene, fondo_penna);
	scene = insert_in_list(scene, corpo_penna);
	scene = insert_in_list(scene, punta_penna);	
	save_scene("vespa.md","scene_vespa",scene);
}
